import asyncio, evdev
import serial
from colored import fg, bg, attr
import sys
from qwerty import find_mouse
from find import find_d1mini
from pythonosc import udp_client, dispatcher, osc_server

SERIAL = 0
SCREEN = 0
DISPLAY = 0

def print_events():
    ldown = 0
    rdown = 0
    lval = 0
    rval = 0
    sustain_decay_value = 123
    sustain_on = False
    
    while True:
        # decay/sustain
        event0 = mouse[0].read_one()

        if event0:
            event = event0
 
            if event.code == 272: # left click
                pass
            elif event.code == 273: # right click
                pass
            elif event.code == 274: # middle click
                pass
            elif event.code == 11: # wheel
                pass
            else:
                if event.code == 1 and event.type == 2:
                    #lval -= event.value/4
                    rval -= event.value/16
                    if rval >= 128:
                        rval = 127
                    if rval < 0:
                        rval = 0
                    if rval >= 112:
                        print_barline("fdk", "val ", rval, 123)
                    else:
                        print_barline("fdk", "val ", rval, 10)
                    osc_client.send_message("/sl/0/set", ["feedback", .3 + rval*.45/128])

def send_midi(cmd, note, vel):
    if SERIAL:
        ser.write(bytes([cmd, note, vel]))
        return
    elif DISPLAY:
        pass

def print_barline(button, action, midi, color):
    endpoint_color = 11
    midi = int(midi)
    barline = "{}\u258f{}{:64}{}\u258f{}".format(fg(endpoint_color),fg(color),int(midi/2)*'\u2588'+(int(midi)%2)*'\u258c',fg(endpoint_color),fg(7))
    print(" {}{}{} {:<4} {} {:>3}{}".format(fg(color),button,fg(7),action,barline,midi,fg(7)))

print_barline('L', "up", 127, 10)
mouse = []
#mouse.append(find_mouse("Logitech Wireless")) # Bluegreen "logi"
mouse.append(find_mouse("logitech M325")) # Solid blue "logitech"
print('Using {}'.format(mouse))
mouse[0].grab()

osc_client = udp_client.SimpleUDPClient("127.0.0.1", port=9951)
#osc_client.send_message("/sl/0/set",["feedback",0.6])
#osc_client.send_message("/sl/1/set",["feedback",0.0])


try:
    print_events()
except KeyboardInterrupt:
    mouse[0].ungrab()
