import sys
import os
from time import sleep
import traceback
import mido
from xenedoji import Pitch
from keyboard import *
from connect import connect
from find import *

# Multiple Keyboards method
# Keyboard(11, 18)
# Keyboard(21, 28)

# Keyboard Slices
# keyboard[11:18]
#   returns a smaller keyboard

# One Keyboard method
# keyboard = Keyboard(11, 88, 'Xenachord')
# keyboard.name = 'Xenachord'


# Start qwerty first

#os.system('fluidsynth -a alsa -g 5 /home/asdf/Downloads/test/jRhodes3b-stereo.sf2 &')

#iport = find_input('qwerty')
#iport = find_input('mscore:mscore-midi-1')
iport = mido.open_input('asdf', virtual=True)

synth = find_output('Synth input port')

#connect(iport, synth)
#sleep(30)

#bottom_key = 40
bottom_key = 21
top_key = 85
top_key = 112
octave = -3
bottom_pitch = Pitch('G#3') * 2**octave
bottom_pitch = Pitch('C4') * 2**octave
keyboard = Keyboard(bottom_key, top_key, '12tone PCPB')
connect(iport, mido.open_output('12tone PCPB'))
#oport = mido.open_output('12tone PCPB2', virtual=True)
sleep(1)
#keyboard.oport = mido.open_output('12tone PCPB', virtual=True
#connect(mido.open_input('12tone PCPB2'), synth)
oport = synth

free_channel = [True] * 8

class ChannelStack:
    def __init__(self):
        self.channel = [True] * 16
        self.channel[9] = False
    def set_free(self, channel):
        self.channel[channel] = True
    def is_free(self, channel):
        return self.channel[channel]
    def set_unfree(self, channel):
        self.channel[channel] = False
    def next_free(self):
        for i in range(16):
            if self.is_free(i):
                self.set_unfree(i)
                channel = i
                break

channel_stack = ChannelStack()

keyschannel = [False]*128*4

F_41edo_bosanquet = [0,4,7,11,14,18,21,  24,28,31,35,38]

# 3/2 = 24\41
# 9/8 = 7\41
# 2187/2048 = 4\41
# 256/243 = 3\41
# 256/243*2187/2048 = 9/8
F_41edo_bosanquet = [0]
Pyth_12_Ls = 'LsLsLssLsLss'
n = 0
for i in range(3):
    for j in range(12):
        if Pyth_12_Ls[j] == 'L':
            n += 4
        else:
            n += 3
        F_41edo_bosanquet.append(n)

# 31edo
# The L and s flip in this layout
# 3/2 = 18\31
# 9/8 = 5\31
# 2187/2048 = 2\31
# 256/243 = 3\41
F_31edo_bosanquet = [0]
Pyth_12_Ls = 'LsLsLssLsLss'
n = 0
for i in range(3):
    for j in range(12):
        if Pyth_12_Ls[j] == 'L':
            n += 2
        else:
            n += 3
        F_31edo_bosanquet.append(n)



# Different ways to midi:
# Every keyboard on it's own channel
# One keyboard with 16 channel pitchbend polyphony
# Four different keyboards like it is now
# 0-128 notes like keyboard = Keyboard(0, 127, 'Xenachord')


scala = [
17/16, 9/8, 19/16, 5/4, 21/16, 11/8, 23/16, 3/2, 13/8, 7/4, 15/8, 2/1,
]
scala = [
10/9, 9/8, 6/5, 27/16, 4/3, 27/20, 3/2, 8/5, 5/3, 9/5, 15/8, 2/1,
]
scala = [
17/16, 9/8, 19/16, 5/4, 21/16, 11/8, 3/2, 25/16, 13/8, 7/4, 15/8, 2/1
]
scala = [
27/16, 9/8, 6/5, 21/16, 4/3, 27/20, 3/2, 8/5, 5/3, 9/5, 15/8, 2/1,
]
scala = [
10/9, 9/8, 81/64, 5/4, 4/3, 27/20, 3/2, 8/5, 5/3, 27/16, 15/8, 2/1,
]
scala = [
10/9, 9/8, 6/5, 5/4, 4/3, 27/20, 3/2, 8/5, 5/3, 9/5, 15/8, 2/1,
]
scala = [
10/9, 9/8, 5/4, 81/64, 4/3, 27/20, 3/2, 5/3, 27/16, 15/8, 243/128, 2/1,
]
scala = [
9/8, 9/8, 5/4, 5/4, 4/3, 27/20, 3/2, 5/3, 5/3, 15/8, 15/8, 2/1,
]
scala = [
9/8, 5/4, 4/3, 27/20, 3/2, 5/3, 5/3, 15/8, 15/8, 2/1, 9/4, 5/2,
]
scala = [
16/15, 9/8, 6/5, 5/4, 4/3, 64/45, 3/2, 8/5, 5/3, 9/5, 15/8, 2/1,
]

#scala = [
#10/9, 9/8, 5/4, 81/64, 4/3, 40/27, 3/2, 5/3, 27/16, 15/8, 243/128, 2/1]
#scala = [
#243/224, 9/8, 32/27, 9/7, 4/3, 81/56, 3/2, 128/81, 12/7, 16/9, 27/14, 2/1]


scala = [r/2 for r in scala[-4:-1]] + [1] + scala + [2*r for r in scala] + [4*r for r in scala] + [8*r for r in scala] + [16*r for r in scala] + [32*r for r in scala]

# Or I could have extended Keyboard like
#   Keyboard_With_Sustain(Keyboard)
#   def interpret(msg)
#       super().interpret(msg)
#           if msg.is_cc(0x40):
#               if msg.value >= 0x40
#                   self.on_sustain_on()
#               else:
#                   self.on_sustain_off()
#   def on_sustain_on(self, msg):
#   def on_sustain_off(self, msg):
#   self.hold_keys

hold_keys = []
# Clean up
untuned_keyboard_index = 0

def sustain_on_callback():
    print('sustain on')
    for key in keyboard.keys_on:
        hold_keys.append(key.pitch.midi())
    # For 12tone octave repeating
    oport.send(mido.Message.from_bytes([176, 64, 127]))

def sustain_off_callback():
    print('sustain off')
    #bottom_key = 33 # This is F3
    midi_keys_on = [key.midi for key in keyboard.keys_on]
    for key in hold_keys:
        if key not in midi_keys_on:
            tuned_note = bottom_pitch * scala[key-bottom_key]
            cents = tuned_note.cents
            # un12 each midi note on its own channel
            #channel = keyschannel[ (key-bottom_key)*4 + untuned_keyboard_index ]
            #keyschannel[ (key-bottom_key)*4 + untuned_keyboard_index ] = False
            # 12tone octave repeating
            channel = (key%12) + (((key%12) + 1) // 10)
            #
            channel_stack.set_free(channel)
            oport.send(mido.Message(note=tuned_note.midi(), channel=channel, type='note_off', velocity=0))
    for i in range(len(hold_keys)):
        hold_keys.pop(-1)
    # For 12tone octave repeating
    oport.send(mido.Message.from_bytes([176, 64, 0]))

def F3_41edo_bosanquet(untuned_keyboard_index, msg, keyboard):
    # None of this works right now
    # bottom_pitch = Pitch('A3') + Interval('-15\\41')
    # bottom_pitch = Pitch('A3') + Edostep(untuned_keyboard_index-15, 41)
    ####

    #bottom_pitch = Pitch('A4') * 2**((untuned_keyboard_index-15)/41)
    print(msg)
    #bottom_key = 33 # This is F3
    if msg.note in range(bottom_key, top_key) and (msg.type == 'note_on' or msg.type == 'note_off'):
        #tuned_note = bottom_pitch * 2**(F_41edo_bosanquet[msg.note-bottom_key]/41)
        tuned_note = bottom_pitch * scala[msg.note-bottom_key]
        cents = tuned_note.cents
        if msg.type == 'note_on' and msg.velocity > 0:
            if keyboard.sustain_on:
                key = msg.note
                if msg.note in hold_keys:
                    # un12 each midi note on its own channel
                    #channel = keyschannel[ (key-bottom_key)*4 + untuned_keyboard_index ]
                    #keyschannel[ (key-bottom_key)*4 + untuned_keyboard_index ] = False
                    # 12tone octave repeating
                    channel = (key%12) + (((key%12) + 1) // 10)
                    #
                    channel_stack.set_free(channel)
                    oport.send(mido.Message(note=tuned_note.midi(), channel=channel, type='note_off', velocity=0))
                    hold_keys.remove(key)
                hold_keys.append(key)
                    
            pb = round(((8192 * cents.value/100) + 8192)/2)
            # un12 each midi note on its own channel
            #for i in range(16):
            #    if channel_stack.is_free(i):
            #        channel_stack.set_unfree(i)
            #        channel = i
            #        break
            # 12tone octave repeating
            key = msg.note
            channel = (key%12) + (((key%12) + 1) // 10)
            #
            oport.send(mido.Message.from_bytes([0xe0|channel, pb&127, pb>>7]))
            msg41 = msg.copy(channel=channel, note=tuned_note.midi())
            print(msg41)
            oport.send(msg41)
            #print((msg.note-bottom_key)*4 + untuned_keyboard_index)
            keyschannel[ (msg.note-bottom_key)*4 + untuned_keyboard_index ] = channel
        elif not keyboard.sustain_on and ( (msg.type == 'note_on' and msg.velocity == 0) or msg.type == 'note_off'):
            # un12 each midi note on its own channel
            #channel = keyschannel[ (msg.note-bottom_key)*4 + untuned_keyboard_index ]
            #keyschannel[ (msg.note-bottom_key)*4 + untuned_keyboard_index ] = False
            # 12tone octave repeating
            key = msg.note
            channel = (key%12) + (((key%12) + 1) // 10)
            #
            channel_stack.set_free(channel)
            oport.send(mido.Message(note=tuned_note.midi(), channel=channel, type='note_off', velocity=0))
    # Never called because Keyboard doesn't support
    #elif msg.is_cc(0x40):
    #    oport.send(msg)

# Change to set_key_callback
keyboard.setcallback(lambda msg: F3_41edo_bosanquet(0, msg, keyboard))
# set_keyboard_callback
keyboard.sustain_on_callback = sustain_on_callback
keyboard.sustain_off_callback = sustain_off_callback

if __name__ == '__main__':
    try:
        while True:
            sleep(0.0001)
        raise KeyboardInterrupt()
        
    except KeyboardInterrupt:
        oport.close()
        #iport.close()
        # keyboard.close()
        exit()
