""" This is to find various things that could be under changing names
    - midi ports
    - MCUs like d1mini and Arduino Uno
"""

import glob
import platform
import mido

def find_d1mini():
    if platform.system() == 'Linux':
        # boards = glob.glob('/dev/ttyA*')
        boards = glob.glob('/dev/ttyUSB*')
    elif platform.system() == 'Darwin':
        boards = glob.glob('/dev/cu.wchusb*')
    if len(boards) == 1:
        return boards[0]
    elif len(boards) > 1:
        print("Warning, multiple d1 mini's found")
        return boards[0]
    else:
        print("Warning, no d1 mini's found")
        return

def find_uno():
    boards = glob.glob('/dev/cu.usbmodem*')
    if len(boards) == 1:
        return boards[0]
    elif len(boards) > 1:
        print("Warning, multiple uno's found")
        return boards[0]
    else:
        print("Warning, no uno's found")
        return

def find_output(name):
    for output in mido.get_output_names():
        if name in output:
            return mido.open_output(output)

def find_outputs(name):
    outputs = []
    for output in mido.get_output_names():
        if name in output:
            outputs.append(mido.open_output(output))
    return outputs

def find_input(name):
    for iport in mido.get_input_names():
        if name in iport:
            return mido.open_input(iport)

def find_inputs(name):
    inputs = []
    for iport in mido.get_input_names():
        if name in iport:
            inputs.append(mido.open_input(iport))
    return inputs

# From hid/qwerty/qwerty.py
def find_qwerty(name=''):
    print(name)
    p = re.compile('(?i)keyboard')
    for dev in [evdev.InputDevice(path) for path in evdev.list_devices()]:
        if p.search(dev.name):
            if name:
                if re.compile('(?i){}'.format(name)).search(dev.name):
                    return dev
            else:
                return dev

def find_mouse(name=''):
    # not both mice say "mouse"
    p = re.compile('(?i)m')
    for dev in [evdev.InputDevice(path) for path in evdev.list_devices()]:
        if p.search(dev.name):
            if name:
                if re.compile('(?i){}'.format(name)).search(dev.name):
                    return dev
            else:
                return dev

#class qwertyStompbox:
#    def find_qwerty(self):
#        p = re.compile('(?i)keyboard')
#        for dev in [evdev.InputDevice(path) for path in evdev.list_devices()]:
#            if p.search(dev.name):
#                return dev

# Check out hid/qwerty/find_midi.py
#   def find_midi_output(name):
#       p = re.compile('(?i)sooper')
#       for name in mido.get_output_names():
#           if p.search(name):
#               return mido.open_output(name)
