import sys, mido
from time import sleep
import traceback
from xenedoji import Pitch
from keyboard import *
from connect import connect
from mido import parse
from find import find_output, find_input

# Multiple Keyboards method
# Keyboard(11, 18)
# Keyboard(21, 28)

# Keyboard Slices
# keyboard[11:18]
#   returns a smaller keyboard

# One Keyboard method
keyboard = Keyboard(11, 88, 'Madness')

#madness = Keyboard('C1', 'A4')
#oport = find_output('Synth input port')
oport = mido.open_output('keypad', virtual=True)


#oport = mido.open_output('FLUID Synth (6544)')

#iport = mido.open_input('Launchpad X MIDI 2')
#iport = mido.open_input('Launchpad:Launchpad MIDI 1 24:0')
#iport = mido.open_input('Launchpad X:Launchpad X MIDI 2 24:1')
#iport = mido.open_input('Launchpad X:Launchpad X MIDI 2 20:1')
iport = find_input('20:1')
if not iport:
    iport = find_input('24:1')

# keyboard should have a midi port
# Everything with a send message should have a midi port
connect(iport, keyboard)

#def setchannels
class ChannelStack:
    def __init__(self):
        self.channel = [True] * 16
    def set_free(self, channel):
        self.channel[channel] = True
    def is_free(self, channel):
        return self.channel[channel]
    def set_unfree(self, channel):
        self.channel[channel] = False

channel_stack = ChannelStack()

# New plan is to check the lauchpad midi and use that for channeling

keyschannel = [False]*89

def keypad(msg): #, keyboard):
    print(msg)
        # Calculate 41edo note
    if msg.type == 'note_on' or msg.type == 'note_off':
        offset = 11 + 3.5*((msg.note//10)-1)
        if msg.note in range(11,89):
            #note41 = Pitch('A2') * 2**((msg.note-offset)/(20.5))
            note41 = Pitch('E6') * 2**((msg.note-offset)/(20.5))
            cents = note41.cents
        if msg.type == 'note_on' and msg.velocity > 0:
            #pb = round(((8192 * cents.value/100) + 8192)/2)
            pb = round(((8192 * cents.value/100) + 8192)/48)
            print(channel_stack.is_free(0))
            print(channel_stack.channel)
            #for i in range(16):
            for i in range(1, 16):
                if channel_stack.is_free(i):
                    channel_stack.set_unfree(i)
                    channel = i
                    break
            oport.send(mido.Message.from_bytes([0xe0|channel, pb&127, pb>>7]))
            #if cents.value < 0:
            #msg41 = msg.copy(channel=channel, note=note41.midi()+(cents.value<0) )
            msg41 = msg.copy(channel=channel, note=note41.midi(), velocity=45 )
            oport.send(msg41)
            keyschannel[msg.note] = channel
            #keyboard[msg.note].note_off_queue(lambda msg: (oport.send(msg.copy(channel=channel), type='note_off'), channel_stack.set_free(channel)))
        elif msg.type == 'note_on' and msg.velocity == 0:
            print('note_on 00')
            note = msg.note
            channel = keyschannel[note]
            keyschannel[note] = False
            channel_stack.set_free(channel)
            oport.send(mido.Message(note=note41.midi(), channel=channel, type='note_off', velocity=0))

    #elif msg.type =='note_off':

    #    oport.send(msg.copy(channel=channel), type='note_off')
    #    channel_stack.set_free(channel))
        

keyboard.setcallback(keypad)

if __name__ == '__main__':
    try:
        #while keyboard.keys_on:
        while True:
            sleep(0.0001)
        raise KeyboardInterrupt()
        
    except KeyboardInterrupt:
        oport.close()
        iport.close()
        exit()
