import mido
from math import log
from find import find_output

#o = mido.open_output('Launchpad X:Launchpad X MIDI 1 20:0')
o = find_output('Launchpad X MIDI')

# The row for Richie, who likes shades of grey
' 00 75 01 76 02 77 03 ' 

# Custom Mode 4
# Made with 1-8 then v-block paste
"""
81 82 83 84 85 86 87 88
71 72 73 74 75 76 77 78
61 62 63 64 65 66 67 68
51 52 53 54 55 56 57 58
41 42 43 44 45 46 47 48
31 32 33 34 35 36 37 38
21 22 23 24 25 26 27 28
11 12 13 14 15 16 17 18
"""

clr_hexstr = """\
00 00 00 03 00 00 00 00
00 03 00 00 00 00 03 00
00 00 00 00 03 00 00 00
00 00 03 00 00 00 00 03
03 00 00 00 00 03 00 00
00 00 00 03 00 00 00 00
00 03 00 00 00 00 03 00
00 00 00 00 03 00 00 00
"""

clr_hexstr = """\
00 00 00 02 00 00 00 00
00 01 00 00 00 00 02 00
00 00 00 00 03 00 00 00
00 00 02 00 00 00 00 01
01 00 00 00 00 02 00 00
00 00 00 03 00 00 00 00
00 02 00 00 00 00 01 00
00 00 00 00 02 00 00 00
"""

clr_hexstr = """\
00 00 00 00 00 00 00 00
0f 00 07 00 03 00 00 00
00 0d 01 05 2f 01 17 00
17 07 0f 03 07 2d 00 15
0d 00 05 2f 03 17 2f 0f
00 0f 01 07 2d 01 15 00
00 00 00 03 00 2f 00 17
00 00 00 00 00 00 00 00
"""
clr_grid = [ [int(i,16) for i in line.split(' ')] for line in clr_hexstr.splitlines()]

clrstr = """\
p pgp zW
Zg  pwgz
pzp g pw
  Ywp  g
G wzpgpW
pwpgz pw
wgpwpzgW
WWwWgwzW
"""

clrstr = """\
        
        
 W      
r w     
W z g y 
 W      
 z g y r
W      w
"""

clrstr = """\
        
y r W   
 Y Rzwg 
   W Z G
Y R W   
 ywrZ G 
   W z g
        
"""

clrstr = """\
        
    W   
 Y R w  
   W Z G
Y R W   
  w Z G 
   W    
        
"""

clrstr = """\
   wzgyr
 wzgyrw 
zgyrwzgy
  wzgyrw
wzgyrw  
gyrwzgyr
 wzgyrw 
zgyrw   
"""

clrstr = """\
 wzgyrw 
zgyrwzgy
  wzgyrw
wzgyrw  
gyrwzgyr
 wzgyrw 
zgyrw   
yrwzgyr 
"""

char_to_color = dict([\
    ('w', 3),
    ('z', 0x2d),
    ('g', 0x15),
    ('y', 0x0d),
    ('r', 0x05),
    (' ', 0),
    ])

char_to_color = dict([\
    ('W', 3),
    ('w', 2),
    ('Z', 0x2d),
    ('z', 0x2e),
    ('G', 0x15),
    ('g', 0x16),
    ('Y', 0x0d),
    ('p', 0x36),
    (' ', 1),
    ])

char_to_color = dict([\
    ('W', 2),
    ('w', 1),
    ('Z', 0x2e),
    ('z', 0x2f),
    ('G', 0x16),
    ('g', 0x17),
    ('Y', 0x0e),
    ('y', 0x0f),
    ('R', 0x06),
    ('r', 0x07),
    ('p', 0x37),
    (' ', 0),
    ])
clr_grid = [ [char_to_color[c] for c in line] for line in clrstr.splitlines()]

def number_to_bytelist(n):
    # This assumes that the first byte is not 0
    return list(n.to_bytes(1 + int(log(n)/log(256)), 'big'))
    # Equivalent to
    return [(n & (255<<i*8))>>i*8 for i in range(int(log(n)/log(256)), -1, -1)]

bytelist = number_to_bytelist(0xf0_00_20_29_02_0c_0e_01_f7)
o.send( mido.Message.from_bytes(bytelist) )
bytelist = number_to_bytelist(0xf0_00_20_29_02_0c_03)

for i in range(8):
    for j in range(8):
        bytelist += [00, 10*(8-i) + j+1, clr_grid[i][j]]

bytelist += [0xf7]

o.send( mido.Message.from_bytes(bytelist) )
