/*
 * Button press sends a sustain message to connected device and
 * computer. It also ligths the led blue and green.
 * 
 * Green flash for midi in events.
 * Blue flash for midi RX events.
 * 
 * Midi mod wheel sets the red led.
 */

#include <MIDIVIL.h>

void onMidiIn(int, int, int);

void setup() {
  Serial.begin(9600);
  pinMode(Rpin, OUTPUT); 
  pinMode(Gpin, OUTPUT);
  pinMode(Bpin, OUTPUT);
  pinMode(Btnpin, INPUT);
  midiSerial.begin(31250);

  for (int i = 0; i < 3; i++) {
    digitalWrite(RGBpin[i], LOW);
  }
}

void loop() {
  buttonEventController();
  midiEventController();
  //updateLed();
}
void onMidiIn(int, int, int) {
  return;
}

void updateLed() {
  if (flashing && millis() > flash_start + flash_interval) {
    flashing = false;
    if (isPressed()) {
      setLed(rgb[0],1023,1023);
    } else {
      setLed(rgb[0],0,0);
    }
  }
}

/*void setLed(int R, int G, int B) {
  analogWrite(Rpin, 1023-R);
  analogWrite(Gpin, 1023-G);
  analogWrite(Bpin, 1023-B);
  rgb[0] = R;
  rgb[1] = G;
  rgb[2] = B;
}*/

void onPress() {
}

void onRelease() {
}

void onLatchOn() {
  // Here to lower Wet/Dry amount
  //sendMidi(0xb0, 15, 32);
  sendMidi(0xb0, 0x61, 127);
  setLed(0,0,511);
}
void onLatchOff() {
  sendMidi(0xb0, 0x61, 0);
  setLed(0,0,0);
}
void onHoldDown() {
}
void onHoldRelease() {
}

// Called onPress of second tap
void onDTapPress() {
}
// Called onRelease of second tap
void onDTapRelease() {
}

// Latching Switches
void onDTapLatchOn() {
}
void onDTapLatchOff() {
}
