 /*
 * Button press sends a sustain message to connected device and
 * computer. It also ligths the led blue and green.
 * 
 * Green flash for midi in events.
 * Blue flash for midi RX events.
 * 
 * Midi mod wheel sets the red led.
 */

#include <midivilin.h>

void onMidiIn(int);

void setup() {  
  Serial.begin(57600);
  pinMode(Rpin, OUTPUT);
  pinMode(Gpin, OUTPUT);
  pinMode(Bpin, OUTPUT);
  pinMode(Btnpin, INPUT);
  midiSerial.begin(31250);
  midiSerial1.begin(31250);

  for (int i = 0; i < 3; i++) {
    digitalWrite(RGBpin[i], LOW);
  }
}

void loop() {
  // buttonEventController();
  // I can't use the button because it could write in the middle of a midi in
  midiEventController();
  updateLed();
}

void updateLed() {
  if (flashing && millis() > flash_start + flash_interval) {
    flashing = false;
    if (isPressed()) {
      setLed(rgb[0],1023,1023);
    } else {
      setLed(rgb[0],0,0);
    }
  }
}

/* void setLed(int R, int G, int B) {
  analogWrite(Rpin, 1023-R);
  analogWrite(Gpin, 1023-G);
  analogWrite(Bpin, 1023-B);
  rgb[0] = R;
  rgb[1] = G;
  rgb[2] = B;
}*/

void onMidiIn(int midibyte) {
  printMidi(midibyte);
  if (midibyte != 254) {
    flash(rgb[0],1023,0);
  }
}

void onPress() {
  // sendMidi(0xb0, 64, 127);
  // printMidi(0xb0, 64, 127);
  // setLed(1023,511,511);
}

void onRelease() {
  // sendMidi(0xb0, 64, 0);
  // printMidi(0xb0, 64, 0);
  // setLed(0,0,0);
}

void onLatchOn() {
}
void onLatchOff() {
}
void onHoldDown() {
}
void onHoldRelease() {
}

// Called onPress of second tap
void onDTapPress() {
}
// Called onRelease of second tap
void onDTapRelease() {
}

// Latching Switches
void onDTapLatchOn() {
}
void onDTapLatchOff() {
}
