/*
 * Button press sends a sustain message to connected device and
 * computer. It also ligths the led blue and green.
 * 
 * Green flash for midi in events.
 * Blue flash for midi RX events.
 * 
 * Midi mod wheel sets the red led.
 */

#ifndef MIDIVIL_h
#define MIDIVIL_h

#include <SoftwareSerial.h>

extern SoftwareSerial midiSerial;
extern SoftwareSerial midiSerial1;

extern int Rpin;
extern int Gpin;
extern int Bpin;
extern int RGBpin[3];
extern int Btnpin;
extern int MIpin;
extern int MOpin;

extern int state;
extern int pressed;
extern int press_start;
extern int latch; // bool

extern int dtap; // bool
extern int tap;
extern int tap_start;

extern int dtap_interval;

extern int hold_start;
extern int hold_time;
extern int held; // bool
extern int holdlatch; // bool
extern int hold_interval;

// This is for buttons that don't release cleanly
// I will not get such a switch for the thing
extern int jitter_interval;
extern int jitter_start;
// This would actually be better if it checked for three events
// in the window.
extern int jitter_check; // Currently unused
////

void setLed(int R, int G, int B);
void buttonEventController();
void onMidiIn(int midibyte);
void onPress();
void onRelease();
void onHoldDown();
void onHoldRelease();
void onLatchOn();
void onLatchOff();
// Called onPress of second tap
void onDTapPress();
// Called onRelease of second tap
void onDTapRelease();
// Latching Switches
void onDTapLatchOn();
void onDTapLatchOff();
bool isPressed();
bool isLatchOn();
bool isDTapLatchOn();

extern unsigned int rgbColor[3];
void updateLed();

extern int decColor;
extern int incColor;
extern int color_step;

extern bool flashing;
extern int flash_start;
extern int flashColor[3];
extern int flash_interval;
void flash(int r, int g, int b);
extern unsigned int rgb[3];

extern int timeout;
//void setLed(int R, int G, int B);
void sendMidi(int cmd, int key, int vel);
void printMidi(int midibyte);
void midiEventController();

#endif
